// Class QCheckBox 
// Filename QCheckBox.h 
// FaPra 2003-2004, A5, Alexander Kramer

#ifndef QCheckBox_h 
#define QCheckBox_h 


//! Pre-declaration of QCheckBox
class QCheckBox;


//! enumeration of mouse buttons
enum QCheckBoxState {cbChecked, cbUnchecked};

#include "QFont.h"
#include "QWidget.h"

//! Check Box
class QCheckBox : public QWidget
{
protected:
//! checked status
QCheckBoxState State;

//! size of the box picture
int BoxSize;

//! caption of the checkbox
string Caption;

//! used to draw caption
QFont* Font;

public:
//! draws itself with OpenGL. Here is the OpenGL drawing code
virtual void draw( QEvent*  e );

//! layout the children widgets. This method is called every time the size is changed. Have to be overwritten for respond on size changes
virtual void layout();

//! have to return true if widget should be dragged with mouse. This method is overwritten in sub classes. If returns true, widget will be dragged
virtual bool canDrag( QEvent*  e );

//! processing mouse/keyboard events which are in widgets region. Mouse coordinates are relative to Owner
virtual bool processEvent( QEvent*  e );

//! processing mouse events which are in Owner widget region. Mouse coordinates are relative to Owner
virtual bool processMouseOwner( QEvent*  e );

//! called if a child is added/removed
virtual void childrenChanged();

//! defines whether control can have keyboard focus. Should return true if Widget wants to get keyboard focus
virtual bool canFocus( QEvent*  e );

//! initialization code
virtual void Init();

//! clean up code
virtual void CleanUp();

//! getter method for State
virtual QCheckBoxState getState();

//! setter method for State
virtual void setState( QCheckBoxState  newValue );

//! getter method for BoxSize
virtual int getBoxSize();

//! setter method for BoxSize
virtual void setBoxSize( int  newValue );

//! getter method for Caption
virtual string getCaption();

//! setter method for Caption
virtual void setCaption( string  newValue );

//! getter method for Font
 QFont* getFont();

//! prints itself to the cout
 void print();

//! Constructor
  QCheckBox( QWidget*  aOwner );

//! Destructor
virtual  ~QCheckBox();


};
#endif

