// Class QFont 
// Font class for drawing text
// Filename QFont.cpp
// FaPra 2003-2004, A5,  Alexander Kramer


#include "DrawText.h"
#include "QFont.h"
#include <GL/glut.h>
#include <iostream>
#include <math.h>
using namespace std;

// ----------------------------------------------------------

//! draws the text with maximum length)
void QFont::draw( const  char*  aText , int  maxLength )
{
  glPushMatrix();
  drawInternal(aText, maxLength);
  glPopMatrix();
} // end of draw()

//! draws the text and ajust the matrix
void QFont::drawInternal( const  char*  aText , int  maxLength )
{
  Color->setAsCurrent();

  glScalef (Size / 16.0, Size / 16.0, 1.0);

  TEXTDRAWER.PrintText(Bold,maxLength, aText);
} // end of drawInternal()

//! draws the text at given position
void QFont::drawAtPos( const  char*  aText , int  x , int  y , int  maxLength )
{
  glPushMatrix();
  glTranslatef(x,y,0);
  drawInternal(aText,maxLength);
  glPopMatrix();
} // end of drawAtPos()

//! returns width of text
float QFont::getTextWidth( const  char*  aText )
{
 return strlen(aText) * 12.0 * Size / 16.0;

} // end of getTextWidth()

//! returns length of string which can be drawn whithin the given width
int QFont::getLengthForWidth( const  char*  aText , int  aWidth )
{
  unsigned int maxlen = (unsigned int)(ceil(aWidth * 16.0 / (Size * 12.0)));
 
  if (maxlen < strlen(aText)) return maxlen;
  else
  return strlen(aText); 

} // end of getLengthForWidth()

//! initialization code
void QFont::Init()
{

} // end of Init()

//! clean up code
void QFont::CleanUp()
{

} // end of CleanUp()

//! getter method for Size
int QFont::getSize()
{
return Size;
} // end of getSize()

//! setter method for Size
void QFont::setSize( int  newValue )
{
Size = newValue;
} // end of setSize()

//! getter method for Bold
bool QFont::getBold()
{
return Bold;
} // end of getBold()

//! setter method for Bold
void QFont::setBold( bool  newValue )
{
Bold = newValue;
} // end of setBold()

//! getter method for Color
QColor* QFont::getColor()
{
return Color;
} // end of getColor()

// WARNING : The implementation of this method will be automatically generated with code generator.
// To prevent this add '//KEEP' at the first line of the implementation.(first line after '{')
//! copy itself from another instance
void QFont::copyFrom( QFont*  from )
{
setSize(from->getSize());
setBold(from->getBold());
Color->copyFrom(from->getColor());
} // end of copyFrom()

// WARNING : The implementation of this method will be automatically generated with code generator.
// To prevent this add '//KEEP' at the first line of the implementation.(first line after '{')
//! prints itself to the cout
void QFont::print()
{
cout << "Class : QFont" << endl;
cout << "Size = " << Size << endl;
cout << "Bold = " << Bold << endl;
} // end of print()

// WARNING : The implementation of this method will be automatically generated with code generator.
// To prevent this add '//KEEP' at the first line of the implementation.(first line after '{')
//! Constructor
 QFont::QFont(  )
{
Bold = false;
Color = new QColor;
Init();
} // end of QFont()

// WARNING : The implementation of this method will be automatically generated with code generator.
// To prevent this add '//KEEP' at the first line of the implementation.(first line after '{')
//! Destructor
 QFont::~QFont()
{
delete Color;
CleanUp();
} // end of ~QFont()

// end of implementation of QFont


