//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
#include "QWidget.h"
#include "QScreen.h"
#include "QWindow.h"
#include "QFont.h"
#include "QButton.h"
#include "QCaptionButton.h"
#include "QCheckBox.h"
#include "QRadioButton.h"
#include "QRadioButtonGroup.h"
#include "QTextEdit.h"
#include "QToolBar.h"


#include <iostream>
using namespace std;

QScreen *screen;

void glutResize(int width, int height)
{
  glViewport(0, 0, width, height);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(0,width,height,0,-1,1);
  glMatrixMode(GL_MODELVIEW);
  screen->setWidth(width);
  screen->setHeight(height);
}

void glutKeyboard(unsigned char key, int x, int y)
{
	switch (key)
	{
		case 27:   std::exit(0);
	}
   screen->glutKeyboard(key,x,y);
}

void glutKeyboardUp(unsigned char key, int x, int y)
{
   screen->glutKeyboardUp(key,x,y);
}


void glutSpecial(int key, int x, int y)
{
 screen->glutSpecialFunc(key,x,y);
}

void glutMotion(int x, int y) 
{
  screen->glutMotion(x,y);
}

void glutMouse(int button, int state, int x, int y)
{
   
    screen->glutMouse(button,state,x,y);  
}

void glutDisplay()
{
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  screen->glutDisplay();
  glutSwapBuffers();
}



void myMethod1(QWidget* Sender, QEvent* e);

void myMethod2(QWidget* Sender, QEvent* e)
{
  QCaptionButton* bn = dynamic_cast<QCaptionButton*>(Sender);
  if (bn)
    cout << "Sie haben " << bn->getCaption() << " angeklickt!" << endl;
  else
    cout << "Methode wurde nicht von einem Button ausgelst" << endl;
}



void myMethod3(QWidget* Sender, QEvent* e)
{
  QRadioButton* bn = dynamic_cast<QRadioButton*>(Sender);
  if (bn)
    cout << "Sie haben " << bn->getCaption() << " angeklickt!" << endl;
  else
    cout << "Methode wurde nicht von einem Button ausgelst" << endl;
}




class MyWindow : public QWindow
{
  private:
    

  public:
    QToolBar* toolbar;
    QTextEdit* textedit;
    QCheckBox* toolbarWidth;
    QRadioButtonGroup* rgroup;
    QToolBar* radio_toolbar;

    void layout()
    {
       QWindow::layout();

    }

    MyWindow(QWidget* Owner):QWindow(Owner),toolbarWidth(0),radio_toolbar(0)
    {
      setWidth(400);
      setHeight(200);

      textedit = new QTextEdit(this);
      textedit->setLeft(10);
      textedit->setTop(70);
      textedit->setWidth(150);
      textedit->setText("Neu !!!");

      // checkbox
      toolbarWidth = new QCheckBox(this);
      toolbarWidth->setLeft(10);
      toolbarWidth->setTop(95);
      toolbarWidth->setCaption("Toolbar Breite anpassen");


      // radio group
      rgroup = new QRadioButtonGroup();

      // toolbar for radio buttons
      radio_toolbar = new QToolBar(this);
      radio_toolbar->setWidth(300);
      radio_toolbar->setTop(150);

      // radio buttons
      QRadioButton * radio1 = new QRadioButton(radio_toolbar);
      radio1->getFont()->setSize(12);
      radio1->setRadioButtonGroup(rgroup);
      radio1->setState(cbChecked);      
      radio1->setCaption("Item 1");
      radio1->onClick = myMethod3;

      QRadioButton * radio2 = new QRadioButton(radio_toolbar);
      radio2->setRadioButtonGroup(rgroup);
      radio2->setCaption("Item 2");
      radio2->setState(cbUnchecked);
      radio2->getFont()->setSize(12);
      radio2->onClick = myMethod3;


      // toobar
      toolbar = new QToolBar(this);

      // create buttons in toolbar
      QCaptionButton * bn = new QCaptionButton(toolbar);
      bn->setCaption("Fenster");
      bn->onPress = myMethod1;

      QCaptionButton * bn2 = new QCaptionButton(toolbar);
      bn2->setCaption("Button 2");
      bn2->onPress = myMethod2;

      QCaptionButton * bn3 = new QCaptionButton(toolbar);
      bn3->setCaption("Button 3");
      bn3->onPress = myMethod2;

      toolbar->setWidth(350);


    }



};


void myMethod1(QWidget* Sender, QEvent* e)
{
  MyWindow* win = dynamic_cast<MyWindow*>(Sender->getOwner()->getOwner());

  if (win)
  {
    MyWindow* newwin = new MyWindow(screen);
    string cap = win->textedit->getText();
    newwin->setCaption(cap);
  }
  
}


void myShutDown(QWidget* Sender, QEvent* e)
{
  std::exit(0);
}

void mySubWindow(QWidget* Sender, QEvent* e)
{
  QWindow * win = new QWindow(screen);
  win->setWidth (200);
  win->setHeight(200);
  QWindow * subwin = new QWindow(win);
  subwin->setWidth(100);
  subwin->setHeight(100);

}

int main(int argc, char* argv[])
{

        glutInit(&argc, argv);
      	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA);

	glutInitWindowSize(500, 400);
	glutInitWindowPosition(100, 100);
	glutCreateWindow("mini QT");

        screen = new QScreen(0);

	QToolBar * toolbar = new QToolBar(screen);
	toolbar->setWidth(420);

	QCaptionButton * bnStart = new QCaptionButton(toolbar);
	bnStart->setCaption("Start");

	QCaptionButton * bnShutDown = new QCaptionButton(toolbar);
	bnShutDown->setCaption("Shut Down");
	bnShutDown->onPress = myShutDown;

	QCaptionButton * bnSubWin = new QCaptionButton(toolbar);
	bnSubWin->setCaption("Sub Window");
	bnSubWin->onPress = mySubWindow;

	toolbar->layout();


        MyWindow* win = new MyWindow(screen);


	glutReshapeFunc(glutResize);
	glutDisplayFunc(glutDisplay);
        glutKeyboardFunc(glutKeyboard);
        glutKeyboardUpFunc(glutKeyboardUp);
        glutSpecialFunc(glutSpecial);
	glutMouseFunc(glutMouse);
        glutMotionFunc(glutMotion);

        glutMainLoop();
        return 0;
}
//---------------------------------------------------------------------------



